Index: tests/regressiontests/admin_scripts/tests.py
===================================================================
--- tests/regressiontests/admin_scripts/tests.py	(revision 11211)
+++ tests/regressiontests/admin_scripts/tests.py	(working copy)
@@ -337,14 +337,14 @@
         args = ['sqlall','--settings=settings', 'admin_scripts']
         out, err = self.run_django_admin(args)
         self.assertNoOutput(out)
-        self.assertOutput(err, 'App with label admin_scripts could not be found')
+        self.assertOutput(err, 'App with label admin_scripts could not be found or caused an error during import')
 
     def test_builtin_with_environment(self):
         "minimal: django-admin builtin commands fail if settings are provided in the environment"
         args = ['sqlall','admin_scripts']
         out, err = self.run_django_admin(args,'settings')
         self.assertNoOutput(out)
-        self.assertOutput(err, 'App with label admin_scripts could not be found')
+        self.assertOutput(err, 'App with label admin_scripts could not be found or caused an error during import')
 
     def test_builtin_with_bad_settings(self):
         "minimal: django-admin builtin commands fail if settings file (from argument) doesn't exist"
@@ -760,21 +760,21 @@
         args = ['sqlall','admin_scripts']
         out, err = self.run_manage(args)
         self.assertNoOutput(out)
-        self.assertOutput(err, 'App with label admin_scripts could not be found')
+        self.assertOutput(err, 'App with label admin_scripts could not be found or caused an error during import')
 
     def test_builtin_with_settings(self):
         "minimal: manage.py builtin commands fail if settings are provided as argument"
         args = ['sqlall','--settings=settings', 'admin_scripts']
         out, err = self.run_manage(args)
         self.assertNoOutput(out)
-        self.assertOutput(err, 'App with label admin_scripts could not be found')
+        self.assertOutput(err, 'App with label admin_scripts could not be found or caused an error during import')
 
     def test_builtin_with_environment(self):
         "minimal: manage.py builtin commands fail if settings are provided in the environment"
         args = ['sqlall','admin_scripts']
         out, err = self.run_manage(args,'settings')
         self.assertNoOutput(out)
-        self.assertOutput(err, 'App with label admin_scripts could not be found')
+        self.assertOutput(err, 'App with label admin_scripts could not be found or caused an error during import')
 
     def test_builtin_with_bad_settings(self):
         "minimal: manage.py builtin commands fail if settings file (from argument) doesn't exist"
@@ -788,7 +788,7 @@
         args = ['sqlall','admin_scripts']
         out, err = self.run_manage(args,'bad_settings')
         self.assertNoOutput(out)
-        self.assertOutput(err, 'App with label admin_scripts could not be found')
+        self.assertOutput(err, 'App with label admin_scripts could not be found or caused an error during import')
 
     def test_custom_command(self):
         "minimal: manage.py can't execute user commands without appropriate settings"
@@ -897,7 +897,7 @@
         args = ['sqlall','admin_scripts']
         out, err = self.run_manage(args)
         self.assertNoOutput(out)
-        self.assertOutput(err, 'App with label admin_scripts could not be found.')
+        self.assertOutput(err, 'App with label admin_scripts could not be found or caused an error during import.')
 
     def test_builtin_with_settings(self):
         "multiple: manage.py builtin commands succeed if settings are provided as argument"
@@ -912,7 +912,7 @@
         args = ['sqlall','admin_scripts']
         out, err = self.run_manage(args,'alternate_settings')
         self.assertNoOutput(out)
-        self.assertOutput(err, 'App with label admin_scripts could not be found.')
+        self.assertOutput(err, 'App with label admin_scripts could not be found or caused an error during import.')
 
     def test_builtin_with_bad_settings(self):
         "multiple: manage.py builtin commands fail if settings file (from argument) doesn't exist"
@@ -926,7 +926,7 @@
         args = ['sqlall','admin_scripts']
         out, err = self.run_manage(args,'bad_settings')
         self.assertNoOutput(out)
-        self.assertOutput(err, "App with label admin_scripts could not be found")
+        self.assertOutput(err, "App with label admin_scripts could not be found or caused an error during import")
 
     def test_custom_command(self):
         "multiple: manage.py can't execute user commands using default settings"
@@ -1067,13 +1067,13 @@
         "User AppCommands can execute when a single app name is provided"
         args = ['app_command', 'NOT_AN_APP']
         out, err = self.run_manage(args)
-        self.assertOutput(err, "App with label NOT_AN_APP could not be found")
+        self.assertOutput(err, "App with label NOT_AN_APP could not be found or caused an error during import")
 
     def test_app_command_some_invalid_appnames(self):
         "User AppCommands can execute when some of the provided app names are invalid"
         args = ['app_command', 'auth', 'NOT_AN_APP']
         out, err = self.run_manage(args)
-        self.assertOutput(err, "App with label NOT_AN_APP could not be found")
+        self.assertOutput(err, "App with label NOT_AN_APP could not be found or caused an error during import")
 
     def test_label_command(self):
         "User LabelCommands can execute when a label is provided"
Index: django/db/models/loading.py
===================================================================
--- django/db/models/loading.py	(revision 11211)
+++ django/db/models/loading.py	(working copy)
@@ -122,7 +122,7 @@
                             return None
                     else:
                         return mod
-            raise ImproperlyConfigured, "App with label %s could not be found" % app_label
+            raise ImproperlyConfigured, "App with label %s could not be found or caused an error during import" % app_label
         finally:
             self.write_lock.release()
 